# Keithley DMM6500 Multimeter

class pymeasure.instruments.keithley.KeithleyDMM6500(adapter, name='Keithley DMM6500 6½-Digit Multimeter', read_termination='\n', **kwargs)

  Bases: `SCPIMixin`, `Instrument`

  Represent the Keithely DMM6500 6½-Digit Multimeter and provide a high-level interface for interacting with the instrument. This class only uses “SCPI” command set (see also `command_set`) to communicate with the instrument.

      # Access via LAN
      ip_address = "xxx.xxx.xxx.xxx"
      dmm = KeithleyDMM6500(f"TCPIP::{ip_address}::inst0::INSTR")

  User can also use PyVISA to get DMM6500’s USB port name and pass it to `KeithleyDMM6500`

      import pyvisa
      rm = pyvisa.ResourceManager()
      resources = rm.list_resources()

      # assume there is only one USB instruments
      # Ex. ('USB0::1510::25856::01234567::0::INSTR')

      dmm = KeithleyDMM6500( resources[0] )

      # Measure voltage
      dmm.measure_voltage()
      print(dmm.voltage)

      # Measure AC voltage
      dmm.measure_voltage(ac=True)
      print(dmm.voltage)

  channels
    Channels:

      `ch_1`: `ScannerCard2000Channel`, `ch_2`: `ScannerCard2000Channel`, `ch_3`: `ScannerCard2000Channel`, `ch_4`: `ScannerCard2000Channel`, `ch_5`: `ScannerCard2000Channel`, `ch_6`: `ScannerCard2000Channel`, `ch_7`: `ScannerCard2000Channel`, `ch_8`: `ScannerCard2000Channel`, `ch_9`: `ScannerCard2000Channel`, `ch_10`: `ScannerCard2000Channel`

  acquire_relative(mode=None)

    Set the active value as the relative for the active mode, or can set another mode by its name.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

    Returns:

      The relative value that was acquired

  property aperture

    Control the aperture time of currently active `mode`.

    Valid values: `MIN`, `DEF`, `MAX`, or number between 8.333u and 0.25 s.

    Note

    Only `voltage`, `current`, `resistance`, `resistance 4W`, `diode`, `temperature`, `frequency`, `period`, and `voltage ratio` mode support aperture setting. If current active mode doesn’t support aperture, this command will hang till adapter’s timeout and cause -113 “Undefined header” error.

  auto_range(mode=None)

    Set the active mode to use auto-range, or can set another mode by its name.

    Only `current` (DC), `current ac`, `voltage` (DC), `voltage ac`, `resistance` (2-wire), `resistance 4W` (4-wire), `capacitance`, and `voltage ratio` support autorange. If chosen mode is not in these modes, this command will do nothing.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

  auto_range_status(mode=None)

    Get the status of auto-range of active mode or another mode by its name. Only `current` (DC), `current ac`, `voltage` (DC), `voltage ac`, `resistance` (2-wire), `resistance 4W` (4-wire), `capacitance`, and `voltage ratio` support autorange. If chosen mode is not in these modes, this command will also return `False`.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

    Returns:

      a bool value for auto-range enabled or disabled

    Return type:

      bool

  property autorange_enabled

    Control the autorange state for currently active `mode`.

    Note

    If currently active mode doesn’t support autorange, this command will hang till adapter’s timeout and cause -113 “Undefined header” error.

  property autozero_enabled

    Control automatic updates to the internal reference measurements (autozero) of the instrument.

  beep(frequency, duration)

    Sound a system beep.

    Parameters:

      - frequency – A frequency in Hz between 20 Hz and 8000 Hz

      - duration – The amount of time to play the tone between 0.001 s to 100 s

    Returns:

      None

  property buffer_points

    Control the number of buffer points. This does not represent actual points in the buffer, but the configuration value instead. 0 means the largest buffer possible based on the available memory when the bufer is created.

  property buffer_size

    Control the number of buffer points. This does not represent actual points in the buffer, but the configuration value instead. 0 means the largest buffer possible based on the available memory when the bufer is created.

  property capacitance

    Measure a capacitance in Farad, based on the active `mode`.

  property capacitance_digits

    Control the number of digits in the capacitance readings (integer strictly from 3 to 6). See also the `digits`.

  property capacitance_range

    Control the capacitance full-scale measure range in Farad. Available ranges are 1e-9, 10e-9, 100e-9, 1e-6, 10e-6, 100e-6, 1e-3. Auto-range is disabled when this property is set. See also the `range`.

  property capacitance_relative

    Control the capacitance relative value in Farad (float strictly from -0.001 to 0.001 F). See also the `relative`.

  property capacitance_relative_status

    Control a relative offset value applied to capacitance measurement. See also the `relative_enabled`.

  close()

    Close the connection

  property command_set

    Control the command set that to use with DMM6500. Reboot the instrument is needed after changing the command set. Available values are: `SCPI`, `TSP`, `SCPI2000`, and `SCPI34401`. The `KeithleyDMM6500` class was designed to use `SCPI` command set only.

    Note

    If you want to use TSP command set, you can use `write()` and `ask()` to send TSP command instead.

  property current

    Measure a DC or AC current in Amps, based on the active `mode`.

  property current_ac_bandwidth

    Control the detector bandwidth in Hz for AC current measurement (integer strictly among 3, 30, and 300).

  property current_ac_digits

    Control the number of digits in the AC current readings (integer strictly from 3 to 6). See also the `digits`.

  property current_ac_range

    Control the AC current positive full-scale measure range in Amps. Available ranges are 1e-3, 10e-3, 100e-3, 1, 3 Amps (for front terminals), and 10 Amps (for rear terminals). See also the `range`.

  property current_ac_relative

    Control the AC current relative value in Amps (float strictly from -3 to 3). See also the `relative`.

  property current_ac_relative_enabled

    Control a relative offset value applied to AC current measurement. See also the `relative_enabled`.

  property current_digits

    Control the number of digits in the DC current readings (integer strictly from 3 to 6). See also the `digits`.

  property current_nplc

    Control the number of power line cycles (NPLC) for the DC current measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  property current_range

    Control the DC current full-scale measure range in Amps. Available ranges are 10e-6, 100e-6, 1e-3, 10e-3, 100e-3, 1, 3 Amps (for front terminals), and 10 Amps (for rear terminals). Auto-range is disabled when this property is set. See also the `range`.

  property current_relative

    Control the DC current relative value in Amps (float strictly from -3 to 3). See also the `relative`.

  property current_relative_enabled

    Control a relative offset value applied to DC current measurement. See also the `relative_enabled`.

  property data_format

    Control data format that is used when transferring readings over the remote interface. Available values are `ASC` (ASCII), `REAL` (double-precision), or `SRE` (single-precision).

  property detector_bandwidth

    Control the lowest frequency expected in the input signal in Hz ONLY for AC voltage and AC current measurement,

    Valid values: 3, 30, 300, `MIN`, `DEF`, `MAX`.

  property digits

    Control the displaying number of digits for currently active `mode`. Available values are from 3 to 6 representing display digits from 3.5 to 6.5.

  property diode

    Measure a diode’s forward voltage drop of general-purpose diodes and the Zener voltage of Zener diodes on the 10V range with a constant test current (bias level), based on the active `mode`.

  property diode_bias

    Control the amount of current in Amps the instrument sources while making measurement. Available bias levels are 1e-5, 0.0001, 0.001, 0.01.

  property diode_nplc

    Control the number of power line cycles (NPLC) for the diode measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  disable_filter(mode=None)

    Disable the averaging filter for the active mode, or can set another mode by its name.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

    Returns:

      Filter status read from the instrument

  disable_relative(mode=None)

    Disable the application of a relative offset value to the measurement for the active mode, or can set another mode by its name.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

  property display_screen

    Set displayed front-panel screen by the name. Available names are: `HOME` (home), `HOME_LARG` (home screen with large readings), `READ` (reading table), `HIST` (histogram), `SWIPE_FUNC` (FUNCTIONS swipe screen), `SWIPE_GRAP` (GRAPH swipe screen), `SWIPE_SEC` (SECONDARY swipe screen), `SWIPE_SETT` (SETTINGS swipe screen), `SWIPE_STAT` (STATISTICS swipe screen), `SWIPE_USER` (USER swipe screen), `SWIPE_CHAN` (CHANNEL swipe screen), `SWIPE_NONS` (NONSWITCH swipe screen), `SWIPE_SCAN` (SCAN swipe screen), `CHANNEL_CONT` (Channel control screen), `CHANNEL_SETT` (Channel settings screen), `CHANNEL_SCAN` (Channel scan screen), or `PROC` (minimal CPU resources).

  displayed_text(top_line=None, bot_line=None)

    Display text messages on the front-panel USER swipe screen. If no messages were defined, screen will be cleared.

    Parameters:

      - top_line – 1st line message

      - bot_line – 2nd line message

    Returns:

      None

  enable_filter(mode=None, type='repeat', count=1)

    Enable the averaging filter for the active mode, or can set another mode by its name.

    Parameters:

      - mode – A valid `mode` name, or None for the active mode

      - type – The type of averaging filter, could be `REPeat`, `MOVing`, or `HYBRid`.

      - count – A number of averages, which can take take values from 1 to 100

    Returns:

      Filter status read from the instrument

  enable_relative(mode=None)

    Enable the application of a relative offset value to the measurement for the active mode, or can set another mode by its name.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

  property frequency

    Measure a frequency in Hz, based on the active `mode`.

  property frequency_aperature

    Control the aperture time in seconds for frequency measurement (float strictly from 2 ms to 273 ms). See also `aperture`.

  property frequency_digits

    Control the number of digits in the frequency readings (integer strictly from 3 to 6). See also the `digits`.

  property frequency_relative

    Control the frequency relative value in Hz (float strictly from -1 MHz to 1 MHz). See also the `relative`.

  property frequency_relative_enabled

    Control a relative offset value applied to frequency measurement. See also the `relative_enabled`.

  property frequency_threshold

    Control the expected input level in Volts for the frequency measurement (float strictly from 0.1 to 750V).

  property frequency_threshold_auto_enabled

    Control the auto threshold range for frequency measurement enabled or not.

  property line_frequency

    Get the power line frequency which automatically detected while the instrument is powered on.

  measure_capacitance(max_capacitance=0.001)

    Configure the instrument to measure capacitance.

    Parameters:

      max_capacitance – Set `capacitance_range` after changing `mode`

    Returns:

      None

  measure_continuity()

    Configure the instrument to perform continuity testing.

    Returns:

      None

  measure_current(max_current=0.01, ac=False)

    Configure the instrument to measure current, based on a maximum current to set the range, and a boolean flag to determine if DC or AC is required.

    Parameters:

      - max_current – A current in Volts to set the current range

      - ac – False for DC current, and True for AC current

  measure_diode()

    Configure the instrument to perform diode testing.

    Returns:

      None

  measure_frequency()

    Configure the instrument to measure frequency.

  measure_period()

    Configure the instrument to measure period.

  measure_resistance(max_resistance=10000000.0, wires=2)

    Configure the instrument to measure resistance, based on a maximum resistance to set the range.

    Parameters:

      - max_resistance (float) – A resistance in Ohms to set the resistance range

      - wires (int) – `2` for normal resistance, and `4` for 4-wires resistance

    Returns:

      None

  measure_temperature()

    Configure the instrument to measure temperature.

  measure_voltage(max_voltage=1, ac=False)

    Configure the instrument to measure voltage, based on a maximum voltage to set the range, and a boolean flag to determine if DC or AC is required.

    Parameters:

      - max_voltage – A voltage in Volts to set the voltage range

      - ac – False for DC voltage, and True for AC voltage

  property mode

    Control the active measure function. Available values are: `current` (DC), `current ac`, `voltage` (DC), `voltage ac`, `resistance` (2-wire), `resistance 4W` (4-wire), `diode`, `capacitance`, `temperature`, `continuity`, `period`, `frequency`, and `voltage ratio`.

  property nplc

    Control the integration time in number of power line cycles (NPLC) of currently active `mode`. This value sets the amount of time that the input signal is measured. Valid values are: 0.0005 to 15 (60Hz) or 12 (50Hz or 400Hz).

    Note

    Only `voltage`, `current`, `resistance`, `resistance 4W`, `diode`, `temperature`, and `voltage ratio` mode support NPLC setting. If current active mode doesn’t support NPLC, this command will hang till adapter’s timeout and cause -113 “Undefined header” error.

  property period

    Measure a period in seconds, based on the active `mode`.

  property period_aperature

    Control the aperture time in seconds for period measurement (float strictly from 2 ms to 273 ms). See also `aperture`

  property period_digits

    Control the number of digits in the period readings (integer strictly from 3 to 6). See also the `digits`.

  property period_relative

    Control the period relative value in seconds (float strictly from -1 s to 1 s). See also the `relative`.

  property period_relative_enabled

    Control a relative offset value applied to period measurement. See also the `relative_enabled`.

  property period_threshold

    Control the expected input level in Volts for the period measurement (float strictly from 0.1 to 750V).

  property period_threshold_auto_enabled

    Control the auto threshold range for period measurement enabled or not.

  property points_in_buffer

    Get the number of readings stored in the buffer.

  property pseudo_scanner_enabled

    Set pseudo scanner card if there’s no scanner card in the instrument. After setting, user can check current scanner card by `scan_id`. If a scanner card is installed, this setting won’t have any effect.

  property range

    Control the positive full-scale measure range for currently active `mode`. Auto-range is disabled when this property is set.

    For frequency and period measurements, ranging applies to the signal’s input voltage, not its frequency

  property relative

    Control the relative offset value of currently active `mode`. When relative offset is enabled, all subsequent measured readings are offset by the value that is set for this command. If the instrument acquires the value, read this setting to return the value that was measured internally. See also the `relative_enabled`.

  property relative_enabled

    Control the relative offset value applied to new measurements for currently active `mode`.

  property resistance

    Measure a resistance in Ohms for both 2-wire and 4-wire configurations, based on the active `mode`.

  property resistance_4W_digits

    Control the number of digits in the 4-wire resistance readings (integer strictly from 3 to 6). See also the `digits`.

  property resistance_4W_nplc

    Control the number of power line cycles (NPLC) for the 4-wire resistance measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  property resistance_4W_range

    Control the 4-wire resistance full-scale measure range in Ohms. Available ranges are: 1, 10, 100, 1e3, 10e3, 100e3, 1e6, 10e6, and 100e6. Auto-range is disabled when this property is set. See also the `range`.

  property resistance_4W_relative

    Control the 4-wire resistance relative value in Ohms (float strictly from -100M to 100M). See also the `relative`.

  property resistance_4W_relative_enabled

    Control a relative offset value applied to 4-wire resistance measurement. See also the `relative_enabled`.

  property resistance_digits

    Control the number of digits in the 2-wire resistance readings (integer strictly from 3 to 6). See also the `digits`.

  property resistance_nplc

    Control the number of power line cycles (NPLC) for the 2-wire resistance measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  property resistance_range

    Control the 2-wire resistance full-scale measure range in Ohms. Available ranges are: 10, 100, 1e3, 10e3, 100e3, 1e6, 10e6, and 100e6. Auto-range is disabled when this property is set. See also the `range`.

  property resistance_relative

    Control the 2-wire resistance relative value in Ohms (float strictly from -100M to 100M). See also the `relative`.

  property resistance_relative_enabled

    Control a relative offset value applied to 2-wire resistance measurement. See also the `relative_enabled`.

  property scan_card_vmax

    Get the maximum voltage of all channels.

  property scan_channels

    Control the channel list of scanning. An empty string will clear the list. Use comma to separate single channel and use a colon to separate the first and last channel in the list. Examples: `1`, `1,3,5`, `1:2, 7:8`, or `1:10`.

  property scan_channels_list

    Get `scan_channels` string to a list of integers.

    For example, when `scan_channels` is `1,3:5,7:8,10`, this attribute will return `[1,3,4,5,7,8,10]`. If `scan_channels_list=[1,2,3,4,6]`, the `scan_channels` will be `1:4,6`.

  property scan_count

    Control the number of times the scan is repeated. Set to `0` set the scan to repeat until aborted.

  property scan_id

    Get scanner card’s ID.

  property scan_interval

    Control the interval time (0s to 100ks) between scan starts when the `scan_count` is more than one.

  property scan_iscomplete

    Get Event Status Register (ESR) bit 0 to determine if previous works were completed. This property is used while running time-consuming scanning operation.

  property scan_modes

    Get a dictionary of every channel’s mode.

  scan_start(block_communication=True, count=None, interval=None)

    Start the scanner card to close each channel of `scan_channels` sequentially and to do measurements.

    If `scan_count` is larger than 1, the next scanning will start again after `scan_interval` second. Running large counts or long interval scanning is a time-consuming operation. It’s better to set `block_communication=False` and use `scan_iscomplete` to check if the measurement is completed.

    Parameters:

      - block_communication – A bool value which controls communication state while scanning. Default is `True` and the communication waits until the commands are complete to accept new commands

      - count – An alternative way to set `scan_count` before scanning.

      - interval – An alternative way to set `scan_interval` in second before scanning.

    Returns:

      None

  scan_stop()

    Abort the scanning measurement by stopping the measurement arming and triggering sequence.

    Returns:

      None

  property scan_vch_end

    Get the last channel in the slot that supports voltage or 2-wire measurements.

  property scan_vch_start

    Get the first channel in the slot that supports voltage or 2-wire measurements.

  scanned_data(start_idx=None, end_idx=None, raw=False)

    Return a list of scanning values from the buffer.

    Parameters:

      - start_idx – A bool value which controls communication state while scanning. Default is `True` and the communication waits until the commands are complete to accept new commands

      - end_idx – An alternative way to set `scan_count`

      - raw – An alternative way to set `scan_interval` in second

    Returns:

      A list of scan channels’ measured

    Return type:

      A list of channels’ list

  property system_time

    Control system time on the instrument. Format of set is: `year, month, day, hour, minute, second` or `hour, minute, second`. Example: Using `time` package to set instrument’s clock: `dmm.system_time = time.strftime("%Y, %m, %d, %H, %M, %S")`

  property temperature

    Measure a temperature in Celsius, based on the active `mode`.

  property temperature_digits

    Control the number of digits in the temperature readings (integer strictly from 3 to 6). See also the `digits`.

  property temperature_nplc

    Control the number of power line cycles (NPLC) for the temperature measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  property temperature_relative

    Control the temperature relative value in Celsius (float strictly from -3310 C to 3310 C). See also the `relative`.

  property temperature_relative_enabled

    Control a relative offset value applied to temperature measurement. See also the `relative_enabled`.

  property terminals_used

    Get which set of input and output terminals the instrument is using. Return can be `FRONT` or `REAR`.

  trigger_single_autozero()

    Cause the instrument to refresh the reference and zero measurements once.

    Consequent autozero measurements are disabled.

  property voltage

    Measure a DC or AC voltage in Volts, based on the active `mode`.

  property voltage_ac_bandwidth

    Control the detector bandwidth in Hz for AC voltage measurement (integer strictly among 3, 30, and 300).

  property voltage_ac_digits

    Control the number of digits in the AC voltage readings (integer strictly from 3 to 6). See also the `digits`.

  property voltage_ac_range

    Control the AC voltage positive full-scale measure range in Volts. Available ranges are 0.1, 1, 10, 100, 750. Auto-range is disabled when this property is set. See also the `range`.

  property voltage_ac_relative

    Control the AC voltage relative value in Volts (float strictly from -750 to 750). See also the `relative`.

  property voltage_ac_relative_enabled

    Control a relative offset value applied to AC voltage measurement. See also the `relative_enabled`.

  property voltage_digits

    Control the number of digits in the DC voltage readings (integer strictly from 3 to 6). See also the `digits`.

  property voltage_nplc

    Control the number of power line cycles (NPLC) for the DC voltage measurement (float strictly from 0.0005 to 15). See also the `nplc`.

  property voltage_range

    Control the DC voltage full-scale measure range in Volts. Available ranges are 0.1, 1, 10, 100, 1000. Auto-range is disabled when this property is set. See also the `range`.

  property voltage_relative

    Control the DC voltage relative value in Volts (float strictly from -1000 to 1000). See also the `relative`.

  property voltage_relative_enabled

    Control a relative offset value applied to DC voltage measurement. See also the `relative_enabled`.

class pymeasure.instruments.keithley.keithleyDMM6500.ScannerCard2000Channel(parent, id)

  Bases: `Channel`

  property autorange_enabled

    Control the autorange state for currently active mode.

    Note

    If current active mode doesn’t support autorange, this command will hang till adapter’s timeout and cause -113 “Undefined header” error.

  disable_filter(mode=None)

    Disable the averaging filter for the active mode, or can set another mode by its name.

    Parameters:

      mode – A valid `mode` name, or None for the active mode

    Returns:

      Filter status read from the instrument

  enable_filter(mode=None, type='repeat', count=1)

    Enable the averaging filter for the active mode, or can set another mode by its name.

    Parameters:

      - mode – A valid `mode` name, or None for the active mode

      - type – The type of averaging filter, could be `REPeat`, `MOVing`, or `HYBRid`.

      - count – A number of averages, which can take take values from 1 to 100

    Returns:

      Filter status read from the instrument

  property mode

    Control the configuration mode for measurements, which can take the values: `current` (DC), `current ac`, `voltage` (DC), `voltage ac`, `resistance` (2-wire), `resistance 4W` (4-wire), `diode`, `capacitance`, `temperature`, `continuity`, `period`, `frequency`, and `voltage ratio`.

  property nplc

    Control the integration time in number of power line cycles (NPLC). Valid values: 0.0005 to 15 (60Hz) or 12 (50Hz or 400Hz) This command is valid only for `voltage`, 2-wire ohms, and 4-wire ohms.

    Note

    Only `voltage`, `current`, `resistance`, `resistance 4W`, `diode`, `temperature`, and `voltage ratio` mode support NPLC setting. If current active mode doesn’t support NPLC, this command will hang till adapter’s timeout and cause -113 “Undefined header” error.

  property range

    Control measuring range for currently active mode. For `frequency` and `period` measurements, `range` applies to the signal’s input voltage, not its frequency

  write(command)

    Write a command to the instrument.